!=====================================================================================
!      list.
!  , ., 2024.
!=====================================================================================

           MEMBER

           INCLUDE('fsListHead.INC')

           MAP
     MODULE('snazzy_win32.lib')
         snazzy_GetDC(LONG), LONG, PASCAL, DLL, PROC, NAME('GetDC')
         snazzy_ReleaseDC(LONG, LONG), LONG, RAW, PASCAL, DLL, PROC, NAME('ReleaseDC')
         snazzy_SetMapMode(LONG, LONG), LONG, PASCAL, DLL, PROC, NAME('SetMapMode')
         snazzy_Rectangle(LONG, LONG, LONG, LONG, LONG), LONG, PASCAL, DLL, PROC, NAME('Rectangle')
         snazzy_DrawEdge(LONG, *snazzy_RECTtype, ULONG, ULONG), LONG, RAW, PASCAL, DLL, PROC, NAME('DrawEdge')
         snazzy_DrawText(LONG, *CSTRING, LONG, *snazzy_RECTtype, ULONG), LONG, RAW, PASCAL, DLL, PROC, NAME('DrawTextA')
         snazzy_CreatePen(LONG, LONG, LONG), LONG, PASCAL, DLL, NAME('CreatePen')
         snazzy_GetTextExtentPoint32(LONG, *CSTRING, LONG, LONG), LONG, RAW, PASCAL, DLL, PROC, NAME('GetTextExtentPoint32A')
         snazzy_SetTextColor(LONG, LONG), LONG, RAW, PASCAL, DLL, PROC, NAME('SetTextColor')
         snazzy_SetBkMode(LONG, LONG), LONG, RAW, PASCAL, DLL, PROC, NAME('SetBkMode')
         snazzy_CreateFont(LONG, LONG, LONG, LONG, LONG, UNSIGNED, UNSIGNED, UNSIGNED,  |
                           UNSIGNED, UNSIGNED, UNSIGNED, UNSIGNED, UNSIGNED, *CSTRING), |
                           LONG, RAW, PASCAL, DLL, PROC, NAME('CreateFontA')
         snazzy_CreateSolidBrush(LONG), LONG, PASCAL, DLL NAME('CreateSolidBrush')
         snazzy_SelectObject(LONG, LONG), LONG, RAW, PASCAL, DLL, PROC, NAME('SelectObject')
         snazzy_DeleteObject(LONG), LONG, RAW, PASCAL, DLL, PROC, NAME('DeleteObject')
         snazzy_InvalidateRect(LONG, LONG, LONG), LONG, RAW, PASCAL, DLL, PROC, NAME('InvalidateRect')
         snazzy_CallWindowProc(LONG, UNSIGNED, UNSIGNED, UNSIGNED, LONG), LONG, PASCAL, RAW, DLL, PROC, NAME('CallWindowProcA')
         snazzy_MulDiv(LONG, LONG, LONG), LONG, PASCAL, NAME('MulDiv')
         snazzy_GetDeviceCaps(LONG, LONG), LONG, PASCAL, NAME('GetDeviceCaps')
         snazzy_GetUpdateRect(LONG, *snazzy_RECTtype, LONG), LONG, PASCAL, RAW, DLL, PROC, NAME('GetUpdateRect')
         snazzy_ValidateRect(LONG, *snazzy_RECTtype), LONG, PASCAL, RAW, DLL, PROC, NAME('ValidateRect')
         snazzy_GetSysColor(LONG), ULONG, PASCAL, DLL, NAME('GetSysColor')
         snazzy_Polygon(LONG, LONG, LONG), LONG, PASCAL, DLL, PROC, NAME('Polygon')
         snazzy_SetProp(LONG, *CSTRING, LONG), LONG, PROC, RAW, PASCAL, NAME('SetPropA')
         snazzy_GetProp(LONG, *CSTRING), LONG, RAW, PASCAL, NAME('GetPropA')
         snazzy_RemoveProp(LONG, *CSTRING), LONG, PROC, RAW, PASCAL, NAME('RemovePropA')
         snazzy_Sleep(LONG), LONG, PROC, PASCAL, NAME('Sleep')
         snazzy_GetWindowLong(LONG, LONG), LONG, PASCAL, NAME('GetWindowLongA')
         snazzy_SetWindowLong(LONG, LONG, LONG), LONG, PROC, PASCAL, NAME('SetWindowLongA')
     END

     !MODULE('fslibs6.lib')
     !    FsDebugOut(string,<byte>)
     !END

     NewWndProc(UNSIGNED, UNSIGNED, UNSIGNED, LONG), LONG, PASCAL  !callback       
           END

! SnazzyLB
snazzy_PropWndProc                CSTRING('snazzy_OldWndProc')
snazzy_PropTarget                 CSTRING('snazzy_Target')
snazzy_PropClassAddr              CSTRING('fsListHeadAddrAddr')
! Windows messages
snazzy_WM_DESTROY                 EQUATE(0002h)
snazzy_WM_PAINT                   EQUATE(000Fh)
snazzy_WM_NCDESTROY               EQUATE(0082h)
! Device Parameters for GetDeviceCaps()
snazzy_LOGPIXELSX                 EQUATE(88)    ! Logical pixels/inch in X
snazzy_LOGPIXELSY                 EQUATE(90)    ! Logical pixels/inch in Y
! Font Equates
snazzy_FW_DONTCARE                EQUATE(0)
snazzy_ANSI_CHARSET               EQUATE(0)
snazzy_DEFAULT_CHARSET            EQUATE(1)
snazzy_OUT_DEFAULT_PRECIS         EQUATE(0)
snazzy_CLIP_DEFAULT_PRECIS        EQUATE(0)
snazzy_DEFAULT_QUALITY            EQUATE(0)
! Font Families
snazzy_FF_DONTCARE                EQUATE(0)  ! Don't care or don't know.
! Background Modes
snazzy_TRANSPARENT                EQUATE(1)
! DrawText() Format Flags
snazzy_DT_TOP                     EQUATE(00000000h)
snazzy_DT_LEFT                    EQUATE(00000000h)
snazzy_DT_CENTER                  EQUATE(00000001h)
snazzy_DT_RIGHT                   EQUATE(00000002h)
snazzy_DT_VCENTER                 EQUATE(00000004h)
snazzy_DT_BOTTOM                  EQUATE(00000008h)
snazzy_DT_SINGLELINE              EQUATE(00000020h)
! Pen Styles
snazzy_PS_SOLID                   EQUATE(0)
snazzy_BDR_RAISEDOUTER            EQUATE(0001h)
snazzy_BDR_RAISEDINNER            EQUATE(0004h)
snazzy_EDGE_RAISED                EQUATE(BOR(snazzy_BDR_RAISEDOUTER, snazzy_BDR_RAISEDINNER))
! Border flags
snazzy_BF_LEFT                    EQUATE(0001h)
snazzy_BF_TOP                     EQUATE(0002h)
snazzy_BF_RIGHT                   EQUATE(0004h)
snazzy_BF_BOTTOM                  EQUATE(0008h)
snazzy_BF_RECT                    EQUATE(BOR(BOR(BOR(snazzy_BF_LEFT, snazzy_BF_TOP), snazzy_BF_RIGHT), snazzy_BF_BOTTOM))
snazzy_BF_ADJUST                  EQUATE(2000h)  ! Calculate the space left over
snazzy_BF_FLAT                    EQUATE(4000h)  ! For flat rather than 3D borders
snazzy_BF_MONO                    EQUATE(8000h)  ! For monochrome borders
! Mapping Modes
snazzy_MM_TEXT                    EQUATE(1)
snazzy_RECTtype GROUP, TYPE
left   LONG
top    LONG
right  LONG
bottom LONG
    END
! Window field offsets for GetWindowLong()
snazzy_GWL_WNDPROC                EQUATE(-4)

!===================================================================================
!  
!
fsListHead.Init PROCEDURE  (pWind, pContr, pTheme)
      CODE
   if SELF.Active=1
      return
   end
   SELF.Active=1
      
   SELF.TargetGroup.TargetWindow &= pWind  
   SELF.ControlList = pContr  

   case pTheme
      of 1   ! 
         SELF.ForegroundColorTheme = COLOR:Black
         SELF.BackgroundColorTheme = 00A9A9A9h
         SELF.GroupForegroundColorTheme=COLOR:Black   
         SELF.GroupBackgroundColorTheme=00A9A9A9h               
      of 2   !windows10 
         SELF.ForegroundColorTheme = COLOR:Black
         SELF.BackgroundColorTheme = COLOR:White
         SELF.GroupForegroundColorTheme=COLOR:Black   
         SELF.GroupBackgroundColorTheme=COLOR:White   
      else
         SELF.ForegroundColorTheme = -1
         SELF.BackgroundColorTheme = -1
         SELF.GroupForegroundColorTheme = -1   
         SELF.GroupBackgroundColorTheme = -1            
   end      
   
   snazzy_SetProp(pContr{PROP:Handle}, snazzy_PropClassAddr, Address(Self))
   snazzy_SetProp(pContr{PROP:Handle}, snazzy_PropWndProc, snazzy_GetWindowLong(pContr{PROP:Handle}, snazzy_GWL_WNDPROC))
   snazzy_SetWindowLong(pContr{PROP:Handle}, snazzy_GWL_WNDPROC, ADDRESS(NewWndProc))
   snazzy_SetProp(pContr{PROP:Handle}, snazzy_PropTarget, SELF.WindowRef)         

!===================================================================================
!  
!
fsListHead.Kill PROCEDURE
      CODE
   if SELF.Active=0
      return
   end

   SELF.Active=0

!===================================================================================
!
!  
!
fsListHead.Destruct PROCEDURE
   CODE
      SELF.Kill
      
!===================================================================================
!
! Callback 
!           
NewWndProc PROCEDURE(UNSIGNED hWnd, UNSIGNED message, UNSIGNED wParam, LONG lParam)
ClassRef    &fsListHead
    CODE
    ClassRef &= snazzy_GetProp(hWnd, snazzy_PropClassAddr)
    If ClassRef &= Null Then Return True .
    Return ClassRef.WndProcM(hWnd, message, wParam, lParam)      
      
!===================================================================================
!
! Callback 
!           
fsListHead.WndProcM PROCEDURE(UNSIGNED hWnd, UNSIGNED message, UNSIGNED wParam, LONG lParam)
snazzy_rect          GROUP(snazzy_RECTtype)
  END
snazzy_hDC            LONG
snazzy_OldPropPixels  LONG
snazzy_OldMapMode     LONG
snazzy_HeaderHeight   LONG
snazzy_OldWndProc     LONG
snazzy_TargetRef     &WINDOW
    CODE
    snazzy_OldWndProc  = snazzy_GetProp(hWnd, snazzy_PropWndProc)
    CASE message
    OF snazzy_WM_PAINT
        snazzy_TargetRef &= (snazzy_GetProp(hWnd, snazzy_PropTarget))
        SetTarget(snazzy_TargetRef)
        snazzy_hDC = snazzy_GetDC(hWnd)
        ! Set pixel mode for the device context
        snazzy_OldMapMode = snazzy_SetMapMode(snazzy_hDC, snazzy_MM_TEXT)
        snazzy_OldPropPixels = 0{PROP:Pixels}
        ! Set pixel mode for Clarion
        0{PROP:Pixels} = True
        snazzy_HeaderHeight = SELF.ControlList{PROP:HeaderHeight}
        0{PROP:Pixels} = snazzy_OldPropPixels
        ! Get the update rectangle in units of pixels
        snazzy_GetUpdateRect(hWnd, snazzy_rect, FALSE)
        snazzy_SetMapMode(snazzy_hDC, snazzy_OldMapMode)
        snazzy_ReleaseDC(hWnd, snazzy_hDC)
        ! Redraw the header if necessary
        IF snazzy_rect.top < snazzy_HeaderHeight
            SELF.ProcMaker 
        END
        SetTarget
    OF snazzy_WM_NCDESTROY
        snazzy_RemoveProp(hWnd, snazzy_PropWndProc)
        snazzy_RemoveProp(hWnd, snazzy_PropTarget)
        snazzy_RemoveProp(hWnd, snazzy_PropClassAddr)
    END
    RETURN snazzy_CallWindowProc(snazzy_OldWndProc, hWnd, message, wParam, lParam)            

!===================================================================================
!
! 
!      
fsListHead.ProcMaker PROCEDURE
snazzy_rect              GROUP(snazzy_RECTtype)
  END
snazzy_rect1             GROUP(snazzy_RECTtype)
  END
snazzy_rect2             GROUP(snazzy_RECTtype)
  END
snazzy_rect3             GROUP(snazzy_RECTtype)
  END
snazzy_rect4             GROUP(snazzy_RECTtype)
  END
snazzy_TextSize          LONG, DIM(2)
snazzy_Points            LONG, DIM(6)
ColumnNumber             LONG
BackgroundColor          LONG
ForegroundColor          LONG
GroupNumber              LONG
GroupBackgroundColor     LONG
GroupForegroundColor     LONG
snazzy_ColumnNumber      LONG
snazzy_Columns           LONG
snazzy_ColumnsInGroup    LONG
snazzy_GroupColumn       LONG
snazzy_LastGroupNumber   LONG
snazzy_HeaderTextInGroup LONG
snazzy_LinesInHeader     LONG
snazzy_MaxLinesInHeader  LONG
snazzy_HeaderLine        LONG
snazzy_State             LONG
snazzy_DoTheGroup        LONG
snazzy_hDC               LONG
snazzy_TextLength        LONG
snazzy_Text              CSTRING(256)
snazzy_GroupText         CSTRING(256)
snazzy_FontName          CSTRING(33)
snazzy_FontHeight        LONG
snazzy_hFont             LONG
snazzy_hOldFont          LONG
snazzy_hBrush            LONG
snazzy_hOldBrush         LONG
snazzy_hPen              LONG
snazzy_hBlackPen         LONG
snazzy_hOldPen           LONG
snazzy_GroupWidth        LONG
snazzy_colWidth          LONG
snazzy_colPosition       LONG
snazzy_Justify           LONG
snazzy_OldPropPixels     LONG
snazzy_OldMapMode        LONG
snazzy_hh                LONG
snazzy_leftBorderOffset  LONG
snazzy_borderFudge       LONG
snazzy_availableHH       LONG
snazzy_Flat              LONG
snazzy_TextFoundFlag     LONG
snazzy_LastTextColumn    LONG
snazzy_Scroll            LONG

snazzy_ScrollPrev        LONG  !.

    CODE
      
    IF SELF.ControlList{PROP:Drop}
       snazzy_hDC  = snazzy_GetDC((SELF.ControlList{PROP:Use, 3}){PROP:Handle})
       snazzy_Flat = TRUE 
    ELSE      
       snazzy_hDC  = snazzy_GetDC(SELF.ControlList{PROP:Handle})
       snazzy_Flat = SELF.ControlList{PROP:Flat}
    END     
    snazzy_FontHeight = snazzy_MulDiv(SELF.ControlList{PROP:FontSize}, snazzy_GetDeviceCaps(snazzy_hDC, snazzy_LOGPIXELSY), 72)
    IF snazzy_FontHeight = 0
        snazzy_FontHeight = snazzy_MulDiv(0{PROP:FontSize}, snazzy_GetDeviceCaps(snazzy_hDC, snazzy_LOGPIXELSY), 72)
    END
    snazzy_FontName = SELF.ControlList{PROP:FontName}
    IF snazzy_FontName = ''
        snazzy_FontName = 0{PROP:FontName}
    END
    snazzy_hFont = snazzy_CreateFont(-snazzy_FontHeight, 0, 0, 0, |
                                     BAND(SELF.ControlList{PROP:FontStyle}, 0FFFh), | Weight
                                     BAND(SELF.ControlList{PROP:FontStyle}, FONT:Italic), | Italic
                                     BAND(SELF.ControlList{PROP:FontStyle}, FONT:Underline), | Underline
                                     BAND(SELF.ControlList{PROP:FontStyle}, FONT:Strikeout), | Strikeout
                                     snazzy_DEFAULT_CHARSET, snazzy_OUT_DEFAULT_PRECIS, snazzy_CLIP_DEFAULT_PRECIS, |
                                     snazzy_DEFAULT_QUALITY, snazzy_FF_DONTCARE, snazzy_FontName)
    snazzy_hOldFont = snazzy_SelectObject(snazzy_hDC, snazzy_hFont)
    snazzy_SetBkMode(snazzy_hDC, snazzy_TRANSPARENT)
    snazzy_OldPropPixels = 0{PROP:Pixels}
    0{PROP:Pixels} = True
    snazzy_OldMapMode = snazzy_SetMapMode(snazzy_hDC, snazzy_MM_TEXT)
    snazzy_hBlackPen = snazzy_CreatePen(snazzy_PS_SOLID, 1, COLOR:Black)
    snazzy_colPosition = 0
    snazzy_hh     = SELF.ControlList{PROP:HeaderHeight}
    snazzy_Columns = SELF.ControlList{PROPLIST:Exists, 0}
    CLEAR(snazzy_rect)
    snazzy_LastGroupNumber   = -1
    snazzy_MaxLinesInHeader  = 1
    !      snazzy_MaxLinesInHeader  
    ! snazzy_LastGroupNumber,       
    LOOP ColumnNumber = 1 TO snazzy_Columns
        snazzy_ColumnsInGroup = SELF.ControlList{PROPLIST:GroupNo + PROPLIST:Group, ColumnNumber}
        IF snazzy_ColumnsInGroup
            GroupNumber = SELF.ControlList{PROPLIST:GroupNo, ColumnNumber}
            IF (snazzy_LastGroupNumber = GroupNumber)
                snazzy_GroupColumn += 1
            ELSE
                snazzy_TextFoundFlag     = FALSE
                snazzy_HeaderTextInGroup = FALSE
                snazzy_GroupColumn       = 1
                snazzy_LastGroupNumber   = GroupNumber
                IF SELF.ControlList{PROPLIST:Header + PROPLIST:Group, ColumnNumber}
                    snazzy_LinesInHeader = 1
                ELSE
                    snazzy_LinesInHeader = 0
                END
            END
            LOOP I# = ColumnNumber TO ColumnNumber + snazzy_ColumnsInGroup - 1
                IF SELF.ControlList{PROPLIST:Header, I#}
                    snazzy_LastTextColumn = I#
                END
            END
            IF SELF.ControlList{PROPLIST:Header, ColumnNumber}
                snazzy_TextFoundFlag = TRUE
            END
            IF SELF.ControlList{PROPLIST:LastOnLine, ColumnNumber}
                IF ColumnNumber <= snazzy_LastTextColumn
                    snazzy_LinesInHeader += 1
                END
                snazzy_TextFoundFlag = FALSE
            ELSIF snazzy_TextFoundFlag AND (snazzy_GroupColumn = snazzy_ColumnsInGroup)
                snazzy_LinesInHeader += 1
                snazzy_TextFoundFlag = FALSE
            END
            IF snazzy_LinesInHeader > snazzy_MaxLinesInHeader
                snazzy_MaxLinesInHeader = snazzy_LinesInHeader
            END
        END
    END
      
    snazzy_ScrollPrev = 0  !.         
    if SELF.ControlList{PROP:HScrollPos} > 0  !.
       snazzy_Scroll = 0  
       LOOP snazzy_ColumnNumber = 1 TO snazzy_Columns  
           IF SELF.ControlList{PROPLIST:Fixed, snazzy_ColumnNumber}  !   
              cycle
           .    
           snazzy_GroupWidth = SELF.ControlList{PROPLIST:Width + PROPLIST:Group, snazzy_ColumnNumber}
           IF snazzy_GroupWidth = 0
              snazzy_ScrollPrev += 1
              CYCLE
           .
           IF snazzy_Scroll >= SELF.ControlList{PROP:HScrollPos} 
              BREAK
           .
           snazzy_ColumnsInGroup = SELF.ControlList{PROPLIST:GroupNo + PROPLIST:Group, snazzy_ColumnNumber}
           if snazzy_ColumnsInGroup
              snazzy_ScrollPrev += snazzy_ColumnsInGroup
              snazzy_ColumnNumber += (snazzy_ColumnsInGroup - 1)  !    
           ELSE
              snazzy_ScrollPrev += 1
           .
           IF SELF.ControlList{PROPLIST:Width + PROPLIST:Group, snazzy_ColumnNumber} <> 0
              snazzy_Scroll += 1
           .
       .  
    .     
      
    snazzy_LastGroupNumber = -1
    LOOP snazzy_ColumnNumber = 1 TO snazzy_Columns
        IF SELF.ControlList{PROPLIST:Fixed, snazzy_ColumnNumber} 
           ColumnNumber = snazzy_ColumnNumber 
        else    
           ColumnNumber = snazzy_ColumnNumber + snazzy_ScrollPrev 
        END
        snazzy_GroupWidth = SELF.ControlList{PROPLIST:Width + PROPLIST:Group, ColumnNumber} 
        IF snazzy_GroupWidth = 0
           CYCLE
        END         

        snazzy_colWidth       = SELF.ControlList{PROPLIST:Width, ColumnNumber}
        GroupNumber           = SELF.ControlList{PROPLIST:GroupNo, ColumnNumber}
        snazzy_GroupText      = SELF.ControlList{PROPLIST:Header + PROPLIST:Group, ColumnNumber}
        snazzy_GroupWidth     = SELF.ControlList{PROPLIST:Width + PROPLIST:Group, ColumnNumber}
        snazzy_ColumnsInGroup = SELF.ControlList{PROPLIST:GroupNo + PROPLIST:Group, ColumnNumber}
        IF snazzy_ColumnsInGroup
            IF snazzy_LastGroupNumber = GroupNumber
                snazzy_GroupColumn += 1
            ELSE
                snazzy_HeaderTextInGroup = FALSE
                snazzy_TextFoundFlag     = FALSE
                snazzy_GroupColumn       = 1
                snazzy_LastGroupNumber   = GroupNumber
                IF snazzy_GroupText
                    snazzy_LinesInHeader = 1
                ELSE
                    snazzy_LinesInHeader = 0
                END
                snazzy_LastTextColumn = 0
                LOOP I# = ColumnNumber TO ColumnNumber + snazzy_ColumnsInGroup - 1
                    IF SELF.ControlList{PROPLIST:Header, I#}
                        snazzy_LastTextColumn = I#
                    END
                END
                LOOP I# = ColumnNumber TO ColumnNumber + snazzy_ColumnsInGroup - 1
                    IF SELF.ControlList{PROPLIST:Header, I#}
                        snazzy_HeaderTextInGroup = TRUE
                        snazzy_TextFoundFlag     = TRUE
                    END
                    IF SELF.ControlList{PROPLIST:LastOnLine, I#}
                        IF I# <= snazzy_LastTextColumn
                            snazzy_LinesInHeader += 1
                        END
                        snazzy_TextFoundFlag  = FALSE
                    ELSIF snazzy_TextFoundFlag AND (I# = ColumnNumber + snazzy_ColumnsInGroup - 1)
                        snazzy_LinesInHeader += 1
                        snazzy_TextFoundFlag  = FALSE
                    END
                END
            END
        ELSE
            snazzy_GroupColumn       = 0
            snazzy_LinesInHeader     = 1
            snazzy_HeaderLine        = 1
            snazzy_HeaderTextInGroup = FALSE
        END

        IF snazzy_GroupColumn AND ~snazzy_HeaderTextInGroup
            snazzy_Text = SELF.ControlList{PROPLIST:Header + PROPLIST:Group, ColumnNumber}
        ELSE
            snazzy_Text = SELF.ControlList{PROPLIST:Header, ColumnNumber}
        END
        snazzy_TextLength = LEN(snazzy_Text)
        BackgroundColor      = -2147483633
        ForegroundColor      = -2147483630
        GroupForegroundColor = -2147483630
        GroupBackgroundColor = -2147483633
         
        ForegroundColor      = SELF.ForegroundColorTheme
        BackgroundColor      = SELF.BackgroundColorTheme
        GroupForegroundColor = SELF.GroupForegroundColorTheme   
        GroupBackgroundColor = SELF.GroupBackgroundColorTheme   
  
        IF BAND(BackgroundColor, 80000000h)
            BackgroundColor = snazzy_GetSysColor(BAND(BackgroundColor, 7FFFFFFFh))
        END
        IF BAND(ForegroundColor, 80000000h)
            ForegroundColor = snazzy_GetSysColor(BAND(ForegroundColor, 7FFFFFFFh))
        END
        IF BAND(GroupBackgroundColor, 80000000h)
            GroupBackgroundColor = snazzy_GetSysColor(BAND(GroupBackgroundColor, 7FFFFFFFh))
        END
        IF BAND(GroupForegroundColor, 80000000h)
            GroupForegroundColor = snazzy_GetSysColor(BAND(GroupForegroundColor, 7FFFFFFFh))
        END
        CASE snazzy_GroupColumn
        OF 0 OROF 1
            snazzy_rect.left = snazzy_rect.right
            IF snazzy_Flat
                snazzy_rect.top = -1
            ELSE  
                snazzy_rect.top = 0
            END
            snazzy_rect.right  = snazzy_rect.left + snazzy_GroupWidth
            snazzy_rect.bottom = snazzy_hh
            snazzy_rect1       = snazzy_rect
            IF snazzy_Flat
                snazzy_DrawEdge(snazzy_hDC, snazzy_rect1, snazzy_EDGE_RAISED, snazzy_BF_TOP + snazzy_BF_FLAT + snazzy_BF_MONO + snazzy_BF_ADJUST)
            ELSE
                snazzy_DrawEdge(snazzy_hDC, snazzy_rect1, snazzy_EDGE_RAISED, snazzy_BF_RECT + snazzy_BF_ADJUST)
            END
            snazzy_rect2            = snazzy_rect1
            snazzy_availableHH      = snazzy_rect1.bottom - snazzy_rect1.top + 1
            snazzy_leftBorderOffset = snazzy_rect1.left - snazzy_rect.left
            IF snazzy_HeaderTextInGroup
                snazzy_rect2.bottom = snazzy_rect2.top + BSHIFT(2 * (snazzy_availableHH / snazzy_MaxLinesInHeader) + 1, -1)
            END
            snazzy_rect3        = snazzy_rect2
            snazzy_HeaderLine   = 0
            snazzy_State        = 0
            IF snazzy_GroupColumn = 1 AND snazzy_GroupText !AND snazzy_HeaderTextInGroup
                snazzy_SetTextColor(snazzy_hDC, GroupForegroundColor)
                snazzy_hBrush    = snazzy_CreateSolidBrush(GroupBackgroundColor)
                snazzy_hPen      = snazzy_CreatePen(snazzy_PS_SOLID, 1, GroupBackgroundColor)
                snazzy_hOldBrush = snazzy_SelectObject(snazzy_hDC, snazzy_hBrush)
                snazzy_hOldPen   = snazzy_SelectObject(snazzy_hDC, snazzy_hPen)
                snazzy_Rectangle(snazzy_hDC, snazzy_rect3.left, snazzy_rect3.top, snazzy_rect3.right, snazzy_rect3.bottom)
                IF SELF.ControlList{PROPLIST:HeaderLeft + PROPLIST:Group, ColumnNumber}
                    snazzy_Justify = snazzy_DT_LEFT
                    snazzy_rect3.left += SELF.ControlList{PROPLIST:HeaderLeftOffset + PROPLIST:Group, ColumnNumber}
                ELSIF SELF.ControlList{PROPLIST:HeaderRight + PROPLIST:Group, ColumnNumber}
                    snazzy_Justify = snazzy_DT_RIGHT
                    snazzy_rect3.right -= SELF.ControlList{PROPLIST:HeaderRightOffset + PROPLIST:Group, ColumnNumber}
                ELSIF SELF.ControlList{PROPLIST:HeaderCenter + PROPLIST:Group, ColumnNumber}
                    snazzy_Justify = snazzy_DT_CENTER
                ELSE
                    snazzy_Justify = 0
                END
                snazzy_DrawText(snazzy_hDC, snazzy_GroupText, -1, snazzy_rect3, snazzy_DT_SINGLELINE + snazzy_DT_VCENTER + snazzy_Justify)

                ! draw separator
                snazzy_SelectObject(snazzy_hDC, snazzy_hBlackPen)
                IF snazzy_HeaderTextInGroup AND (snazzy_GroupColumn = 1)
                    snazzy_Points[1] = snazzy_rect2.left
                    snazzy_Points[2] = snazzy_rect2.bottom - 1
                    snazzy_Points[3] = snazzy_rect2.right - 1
                    snazzy_Points[4] = snazzy_Points[2]
                    snazzy_Polygon(snazzy_hDC, ADDRESS(snazzy_Points), 2)
                END

                snazzy_SelectObject(snazzy_hDC, snazzy_hOldBrush)
                snazzy_DeleteObject(snazzy_hBrush)
                snazzy_SelectObject(snazzy_hDC, snazzy_hOldPen)
                snazzy_DeleteObject(snazzy_hPen)
                snazzy_rect2.top    = snazzy_rect2.bottom
                snazzy_rect2.bottom = snazzy_rect2.top + BSHIFT((2 * snazzy_availableHH / snazzy_MaxLinesInHeader) + 1, -1)
                snazzy_HeaderLine   = 1
            END
            ! draw border
            snazzy_SelectObject(snazzy_hDC, snazzy_hBlackPen)
            IF SELF.ControlList{PROPLIST:RightBorder + PROPLIST:Group, ColumnNumber}
                snazzy_Points[1] = snazzy_rect.right
                snazzy_points[2] = 0
                snazzy_Points[3] = snazzy_Points[1]
                snazzy_Points[4] = snazzy_rect.bottom - 1
                snazzy_Polygon(snazzy_hDC, ADDRESS(snazzy_Points), 2)
                snazzy_rect.right += 1
            END
        END

        IF snazzy_GroupColumn AND ~snazzy_HeaderTextInGroup
            CYCLE
        END

        CASE snazzy_State
        OF 0 ! First line (after header, if it exists)
            snazzy_HeaderLine  += 1
            snazzy_colPosition  = snazzy_rect.left
            snazzy_rect3        = snazzy_rect2
            snazzy_borderFudge  = snazzy_leftBorderOffset
        OF 1 ! New line
            snazzy_HeaderLine  += 1
            snazzy_colPosition  = snazzy_rect.left
            snazzy_rect3.left   = snazzy_rect2.left
            snazzy_rect3.top    = snazzy_rect3.bottom
            snazzy_rect3.bottom = snazzy_rect1.top + BSHIFT(((2 * snazzy_HeaderLine * snazzy_availableHH) / snazzy_MaxLinesInHeader) + 1, -1)
            snazzy_borderFudge  = snazzy_leftBorderOffset
        OF 2 ! Second (or greater column) on same line
            snazzy_rect3.left   = snazzy_rect3.right
            snazzy_rect3.top    = snazzy_rect3.top
            snazzy_rect3.bottom = snazzy_rect3.bottom
            snazzy_borderFudge  = 0
        END

        IF SELF.ControlList{PROPLIST:LastOnLine, ColumnNumber} OR (snazzy_GroupColumn = snazzy_ColumnsInGroup)
            snazzy_rect3.right = snazzy_rect1.right
            snazzy_colWidth    = snazzy_rect3.right - snazzy_rect3.left
        ELSE
            ! fudge factor is subtracted from the first column on a line to
            ! cancel out the shift caused by the column border (see DrawEdge)
            snazzy_rect3.right = snazzy_rect3.left + snazzy_colWidth - snazzy_borderFudge
        END
        IF snazzy_HeaderLine = snazzy_LinesInHeader
            ! if this is the last line in the header, make sure it extends to the bottom
            ! (correction for truncations in snazzy_availableHH / snazzy_MaxLinesInHeader)
            snazzy_rect3.bottom = snazzy_rect1.bottom
        END
        snazzy_rect4 = snazzy_rect3
        IF snazzy_GroupColumn AND ~snazzy_HeaderTextInGroup
            snazzy_SetTextColor(snazzy_hDC, GroupForegroundColor)
            snazzy_hBrush     = snazzy_CreateSolidBrush(GroupBackgroundColor)
            snazzy_hPen       = snazzy_CreatePen(snazzy_PS_SOLID, 1, GroupBackgroundColor)
            snazzy_DoTheGroup = PROPLIST:Group
        ELSE
            snazzy_SetTextColor(snazzy_hDC, ForegroundColor)
            snazzy_hBrush     = snazzy_CreateSolidBrush(BackgroundColor)
            snazzy_hPen       = snazzy_CreatePen(snazzy_PS_SOLID, 1, BackgroundColor)
            snazzy_DoTheGroup = 0
        END
        snazzy_hOldBrush = snazzy_SelectObject(snazzy_hDC, snazzy_hBrush)
        snazzy_hOldPen   = snazzy_SelectObject(snazzy_hDC, snazzy_hPen)
        snazzy_Rectangle(snazzy_hDC, snazzy_rect4.left, snazzy_rect4.top, snazzy_rect4.right, snazzy_rect4.bottom)
        IF SELF.ControlList{PROPLIST:HeaderLeft + snazzy_DoTheGroup, ColumnNumber}
            snazzy_Justify = snazzy_DT_LEFT
            snazzy_rect4.left += SELF.ControlList{PROPLIST:HeaderLeftOffset + snazzy_DoTheGroup, ColumnNumber}
        ELSIF SELF.ControlList{PROPLIST:HeaderRight + snazzy_DoTheGroup, ColumnNumber}
            snazzy_Justify = snazzy_DT_RIGHT
            snazzy_rect4.right -= SELF.ControlList{PROPLIST:HeaderRightOffset + snazzy_DoTheGroup, ColumnNumber}
        ELSIF SELF.ControlList{PROPLIST:HeaderCenter + snazzy_DoTheGroup, ColumnNumber}
            snazzy_Justify = snazzy_DT_CENTER
        ELSE
            snazzy_Justify = 0
        END
        snazzy_DrawText(snazzy_hDC, snazzy_Text, snazzy_TextLength, snazzy_rect4, snazzy_DT_SINGLELINE + snazzy_DT_VCENTER + snazzy_Justify)
        ! Draw right border
        snazzy_SelectObject(snazzy_hDC, snazzy_hBlackPen)
        IF snazzy_GroupColumn AND (snazzy_GroupColumn <> snazzy_ColumnsInGroup)
            IF SELF.ControlList{PROPLIST:RightBorder, ColumnNumber} AND ~SELF.ControlList{PROPLIST:LastOnLine, ColumnNumber}
                snazzy_Points[1] = snazzy_colPosition + snazzy_colWidth - 1
                IF snazzy_GroupColumn
                    snazzy_points[2] = snazzy_rect4.top
                ELSE
                    snazzy_points[2] = 0
                END
                snazzy_Points[3] = snazzy_Points[1]
                snazzy_Points[4] = snazzy_rect4.bottom
                snazzy_Polygon(snazzy_hDC, ADDRESS(snazzy_Points), 2)
            END
        END

        ! Column clean up
        snazzy_SelectObject(snazzy_hDC, snazzy_hOldBrush)
        snazzy_DeleteObject(snazzy_hBrush)
        snazzy_SelectObject(snazzy_hDC, snazzy_hOldPen)
        snazzy_DeleteObject(snazzy_hPen)

        IF SELF.ControlList{PROPLIST:LastOnLine, ColumnNumber}
            snazzy_State = 1
        ELSE
            snazzy_State = 2
        END
        snazzy_colPosition += snazzy_colWidth

        IF ColumnNumber >= snazzy_Columns
            BREAK
        END
    END

    ! Draw bottom and right border 
    IF snazzy_Flat
        snazzy_hOldPen = snazzy_SelectObject(snazzy_hDC, snazzy_hBlackPen)
        snazzy_Points[1] = 0
        snazzy_Points[2] = snazzy_hh - 1
        snazzy_Points[3] = snazzy_rect.right - 2
        snazzy_Points[4] = snazzy_Points[2]
        snazzy_Polygon(snazzy_hDC, ADDRESS(snazzy_Points), 2)
        snazzy_Points[1] = snazzy_rect.right - 2
        snazzy_Points[2] = 0
        snazzy_Points[3] = snazzy_Points[1]
        snazzy_Points[4] = snazzy_hh - 1
        snazzy_Polygon(snazzy_hDC, ADDRESS(snazzy_Points), 2)
        snazzy_SelectObject(snazzy_hDC, snazzy_hOldPen)
    END
       
    ! Validate the rectangle we've painted.
    snazzy_rect.top    = 0
    snazzy_rect.left   = 0
    snazzy_rect.bottom = snazzy_hh
    IF SELF.ControlList{PROP:Drop}
        snazzy_rect.right  += 1
        snazzy_ValidateRect((SELF.ControlList{PROP:Use, 3}){PROP:Handle}, snazzy_rect)
    ELSE      
        snazzy_rect.right -= 1
        snazzy_ValidateRect(SELF.ControlList{PROP:Handle}, snazzy_rect)
    END     

    ! Final clean up
    snazzy_DeleteObject(snazzy_hBlackPen)
    snazzy_SelectObject(snazzy_hDC, snazzy_hOldFont)
    snazzy_DeleteObject(snazzy_hFont)
    snazzy_SetMapMode(snazzy_hDC, snazzy_OldMapMode)
    snazzy_ReleaseDC(SELF.ControlList{PROP:Handle}, snazzy_hDC)
    0{PROP:Pixels} = snazzy_OldPropPixels
      
      

